#!/usr/local/bin/perl 

use strict;
use warnings;

use lib qw ( bioperl-live modules ensembl/modules ensembl-external/modules lib/perl );

use DBI;
use Bio::EnsEMBL::DBLoader;
use Bio::EnsEMBL::DBSQL::SQL::StatementHandle;
use CSHL::Config;


#    my $ENSEMBL_ORACLE_HOME='/oracle1/app/oracle/product/8.1.7';
#    #my $ENSEMBL_TWO_TASK='P:rice';
#    my $ENSEMBL_TWO_TASK='T:localhost:rice';
#    $ENV{ORACLE_HOME} = $ENSEMBL_ORACLE_HOME if ($ENSEMBL_ORACLE_HOME) ;
#    $ENV{TWO_TASK} = $ENSEMBL_TWO_TASK if ($ENSEMBL_TWO_TASK) ;
#    $ENV{ORA_PIPES} = "V2";
#    $ENV{TNS_ADMIN}=$ENSEMBL_ORACLE_HOME.'/network/admin';

    my $db=Bio::EnsEMBL::DBLoader->new( GMAPLocator);

my $sth=$db->prepare('select marker,clone from marker_clone') 
					or die "prepare:".$db->errstr;
$sth->execute or die "execute:".$db->errstr;

while(my($marker,$clone)=$sth->fetchrow_array) {
    $marker=~ s/\..*//;
    print qq(Marker : "$marker"\nIn_ensembl $clone\nHELP\tMarker_Help\n\n);
    print STDERR qq(Marker : "$marker"\n-D In_ensembl\n\n);
}
